<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.1"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlarmScreenNg: Help files</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlarmScreenNg
   &#160;<span id="projectnumber">0.9.2</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li class="current"><a href="pages.html"><span>Related&#160;Pages</span></a></li>
    </ul>
  </div>
<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="page_References.html">References</a></li>  </ul>
</div>
</div><!-- top -->
<div class="PageDoc"><div class="header">
  <div class="headertitle">
<div class="title">Help files </div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><p>Custom help files can be added to the project, and NG AS will be able to find and display them, provided that the names of files with help information and their location on disk follows some predefined rules. The rules are inherited from existing JCOP Alarm Screen in order to reuse existing help files (if any).</p>
<p>The very first place where searching for help file name is <b>_string_05</b> attribute of <b>_general</b> config for DPE where alarm came from. If the attribute is set and contains non-empty string - this is assumed to be the name of file with help, and no further search is performed.</p>
<h1><a class="anchor" id="sec_RefHelpFilestypes"></a>
File types</h1>
<p>NG AS will only searches for files of types, which were registered in project using dedicated <a class="el" href="page_ConfigAdmin.html#sec_HelpFileTypes">panel</a>. See also <a class="el" href="page_RefJson.html#subsebsec_RefJsonAdminHelpFile">Help file types</a>.</p>
<h1><a class="anchor" id="sec_RefHelpFilesSearch"></a>
Search order</h1>
<p>NG AS searches for help files under the directory <b>HELP_REL_PATH/AlarmHelp/</b>, futher in this section referred to as 'help root'.</p>
<p>The overall logic of search for help files is based on two statements: </p><ol>
<li>
There is a natural hierarchy of items, associated with particular alarm: <ul>
<li>
DP type <ul>
<li>
DP <ul>
<li>
DPE &lt;&lt;&lt; alarm comes here </li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
<li>
The help file for 'more specific' item shall be used (if exists) instead of help file for 'more generic' item. </li>
</ol>
<p>One more rule which is used, but this is more JCOP-specific: <b>description</b> is 'more specific' than <b>alias</b>, which is in turn 'more specific' than <b>name</b>.</p>
<p>Taking these rules into account, the logic for searching help files to display looks rather natural. The following directories are searched (under help root!) in this order, and in every directory NG AS searches for two files (again, in this order):</p>
<table class="doxtable">
<tr>
<th>Directory name </th><th>File name(s)  </th></tr>
<tr>
<td>DeviceDescriptionDPE </td><td><ol>
<li>
{system_name}{dpe_description}{dpe_name}{suffix} </li>
<li>
{dpe_description}{dpe_name}{suffix} </li>
</ol>
</td></tr>
<tr>
<td>DeviceDescription </td><td><ol>
<li>
{system_name}{dp_description}{dpe_name}{suffix} </li>
<li>
{dp_description}{dpe_name}{suffix} </li>
</ol>
</td></tr>
<tr>
<td>DeviceDescriptionDPE </td><td><ol>
<li>
{system_name}{dpe_alias}{dpe_name}{suffix} </li>
<li>
{dpe_alias}{dpe_name}{suffix} </li>
</ol>
</td></tr>
<tr>
<td>DeviceDescription </td><td><ol>
<li>
{system_name}{dp_alias}{dpe_name}{suffix} </li>
<li>
{dp_alias}{dpe_name}{suffix} </li>
</ol>
</td></tr>
<tr>
<td>DeviceDPE </td><td><ol>
<li>
{system_name}{dp_name}{dpe_name}{suffix} </li>
<li>
{dp_name}{dpe_name}{suffix} </li>
</ol>
</td></tr>
<tr>
<td>Device </td><td><ol>
<li>
{system_name}{dp_name}{suffix} </li>
<li>
{dp_name}{suffix} </li>
</ol>
</td></tr>
<tr>
<td>DeviceTypeDPE </td><td><ol>
<li>
{system_name}{dp_type_name}{dpe_name}{suffix} </li>
<li>
{dp_type_name}{dpe_name}{suffix} </li>
</ol>
</td></tr>
<tr>
<td>DeviceType </td><td><ol>
<li>
system_name}{dp_type_name}{suffix} </li>
<li>
{dp_type_name}{{suffix} </li>
</ol>
</td></tr>
</table>
<p>Some more comments on algorithm for help file search: </p><ul>
<li>
In all file names, built according to rules above, character replacement is done before search: slash (<b>/</b>) and colon (<b>:</b>) characters are replaced with underscore (<b>_</b>).  </li>
<li>
For given combination of directory and file name, the existense of files with one of registered <a class="el" href="page_ConfigAdmin.html#sec_HelpFileTypes">file types</a> is checked before moving to next file/directory name.  </li>
</ul>
</div></div><!-- contents -->
</div><!-- PageDoc -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.1
</small></address>
</body>
</html>
